/*======================================================================
  
  filename :  sumo.c
  target   :  z^o{bg
                   ^[QbgZTF6ch
                   CZTFO2ch
  last edit:  00/10/12

  RpCiHitech-C CrossZ80 7.11j
    ROM擪AhXF0000HARAM擪AhXF8000HARAMe8KB̏ꍇ̗  
    x>  zc  -O  -A0,8000,1F00  sumo.c
          -O:IveB}CY
          -A*1,*2,*3:  *1:ROM擪ڽ  *2:RAMڽ  *3:RAMe

=======================================================================*/

#define  notINTR_TEST   /*  CZT   INTR_TEST  */
#define  notMOTOR_TEST  /*  s[^     MOTOR_TEST */

/*-----------------------------------------------------------------------
  Hitech-C  wb_
*/
#include  <sys.h>       /*  IOo͊֐  */
#include  <intrpt.h>    /*  荞݊֐  */

/*-----------------------------------------------------------------------
  [h1荞݃xN^
       ROMɏޏꍇF0x0038
*/
#define  IRQV  ((isr  *)0x38)

/*-----------------------------------------------------------------------
    }CNvZbT    TMPZ84C0
*/
#define  PIOAD    0x1C       /*  PIO  Aްڼ޽ڽ  */
#define  PIOAC    PIOAD+1    /*  PIO  Aڼ޽ڽ  */
#define  PIOBD    PIOAD+2    /*  PIO  Bްڼ޽ڽ    */
#define  PIOBC    PIOAD+3    /*  PIO  Bڼ޽ڽ  */
#define  SIOAD    0x18       /*  SIO  Aްڼ޽ڽ    */
#define  SIOAC    SIOAD+1    /*  SIO  Aڼ޽ڽ  */
#define  SIOBD    SIOAD+2    /*  SIO  Bްڼ޽ڽ    */
#define  SIOBC    SIOAD+3    /*  SIO  Bڼ޽ڽ  */
#define  CTC0     0x10       /*  CTC  0ڽ  */
#define  CTC1     CTC0+1     /*  CTC  1ڽ  */
#define  CTC2     CTC0+2     /*  CTC  2ڽ  */
#define  CTC3     CTC0+3     /*  CTC  3ڽ  */
#define  HMCR     0xf0       /*  Ӱ޺۰ڼ޽ڽ  */
#define  HMSR     0xf1       /*  Ӱސݒڼ޽ڽ  */
#define  HINT     0xf4       /*  D揇ʐݒڼ޽ڽ(޲-)  */


/*-----------------------------------------------------------------------
  \tgEFA^C}萔
*/
#define  TIMER    30000      /* 1b..덷F5% */

/*-----------------------------------------------------------------------
  ֐vg^Cv
*/
void    io_initial(void);    /*  ̪  Ƽײ  */
int     getbit1(int,int);    /*  8ޯް1ޯĒo  */
void    wait_start_sw(void); /*  Ľ܂ő҂  */
void    wait_5_sec(void);    /*  5b̿ĳ  */
void    led(int);            /*  LEDݸ  */
void    delay_1(void);       /*  1b̿ĳ(LEDݸt)  */
void    fight(void);         /*  ΐ  */
void    maint(void);         /*  Ԃݽ  */
void    motor_off(void);     /*  Ӱڰ/*/
void    motor_brk(void);     /*  Ӱڰ(ϕt)  */
void    fwd(void);           /*  Oi  */
void    back(void);          /*    */
void    right_turn(void);    /*  E] */
void    left_turn(void);     /*  ]  */
void    timer(int);          /*  ėpĳ  */
/*-----荞(gp) */
void  interrupt  int1(void);

/*-----------------------------------------------------------------------
    o{bg  n[hEFA
*/
#define  LED_PORT    PIOBD   /*  j^LED  */
#define  START_SW    PIOBD   /*  X^[gXCb`  */
#define  MOTOR       PIOBD   /*  DC[^  */
#define  SCANER      PIOAD   /*  ^[QbgZT  */
#define  L_SENSOR    PIOAD   /*  CZT  */
#define  LED_ON      0xf2    /*  LEDon,[^u[L   11110010B */
#define  LED_OFF     0xf0    /*  LEDoff,[^u[L  11110000B */

/*  [^--------------*/
#define  FWD         0xa4    /*  Oi         10101000B  */
#define  BACK        0x54    /*           01011000B  */
#define  RIGHT       0x94    /*  Eɒn]    10011000B  */
#define  LEFT        0x64    /*  ɒn]    01101000B  */
#define  BRK         0xf4    /*  u[L      11111000B  */

/*  CZT-------  */
#define  SLL         0       /*  is    */
#define  SLR         1       /*  isE    */

/*  ^[QbgZT----*/
#define  STL1        2       /*                    */
#define  STL2        3       /*           b         */
#define  STL3        4       /*       STL1  STR1     */
#define  STR1        5       /*     STL2      STR2   */
#define  STR2        6       /*    STL3        STR3  */
#define  STR3        7       /*                      */


/*-----------------------------------------------------------------------
  main()֐
*/
int  main(void)
{
    di();                   /*  荞݋֎~  */
    set_vector(IRQV,int1);  /*  荞݃[h1xN^Zbg  int1(void)*/
    asm("IM  1");           /*  荞݃[h1    */
    io_initial();           /*  C^tF[X̃CjVCY  */
    motor_off();            /*  DC[^u[LAoL[NvON  */

/*CZTij^LEDɂmFBj  */
#ifdef  INTR_TEST
    while(1)    
        if(  inp(L_SENSOR)  &  0x03  )  /*  00000011B  */
            led(1);
#endif

/*s[^iOiނJԂ)  */
#ifdef  MOTOR_TEST
    wait_start_sw();
    while(1){
       fwd(); timer(22000); motor_brk();  
       back();timer(22000); motor_brk(); 
    }
#endif


    /*CZT̈ONł΁A^C̃eiX[h
        s[^ᑬ]A^C̉@B
    */
    if(  inp(L_SENSOR)  &  0x03  )  maint();

    /*CZTQƂOFFł΁At@Cg[h  */
    led(10);    /*  t@Cg[hbZ[WiLED10_Łj*/
    wait_start_sw();
    wait_5_sec();    /*  5b̃\tgEFA^C}  */
    fight();         /*  ΐ(iv[v)*/

    return  0;
}

/*---------------------------------------------------------------------
  키
*/
void  fight(void)
{
    int  line_sensor;  /*  CZTf[^ obt@  */
    int  scaner;       /*  ^[QbgZTf[^ obt@  */

    while(1){
        fwd();  timer(300);         /*  킸ɑOi  */
        line_sensor=inp(L_SENSOR);  /*  CZTf[^  */
        scaner      =inp(SCANER);   /*  ^[QbgZTf[^  */

        /*  CZT`FbN-----------------------------------*/
        /*@CZTONł΁A^[Qbg𔭌܂ŉE]*/
        if(  getbit1(line_sensor,SLL)  ){
            motor_brk();    /*  u[L  */

            /*  ^[Qbg𔭌܂ŉE]  */
            right_turn();
            while(    getbit1(inp(SCANER),STR1)
                  &&  getbit1(inp(SCANER),STL1)  );
 
            /*  ^[Qbg𔭌A߉  */
            motor_brk();    /*  u[L  */
            fwd();          /*  Oi  */
            timer(4000);
            motor_brk();    /*  u[L  */
            back();         /*    */
            timer(8000);
            motor_brk();    /*  u[L  */
        }
        /*AE̫Ĳonł΁A^[Qbg𔭌܂ō]*/
        else  if(getbit1(line_sensor,SLR)){
            motor_brk();    /*  u[L  */

            /*  ^[Qbg𔭌܂ō]  */
            left_turn();
            while(    getbit1(inp(SCANER),STR1)
                  &&  getbit1(inp(SCANER),STL1)  );

            /*  ^[Qbg𔭌A߉  */
            motor_brk();    /*  u[L  */
            fwd();          /*  Oi  */
            timer(4000);
            motor_brk();    /*  u[L  */
            back();         /*    */
            timer(8000);
        }

        /*^[QbgZT`FbN  */
        /*@^[QbgɂꍇAɉ]B  */
        if      ((      (getbit1(scaner,STL2))
                  ||    (getbit1(scaner,STL3))  )
                  &&    (!getbit1(scaner,STL1))
                  &&    (!getbit1(scaner,STR1))    ){
                     motor_brk();  left_turn();
                     while(  getbit1(inp(SCANER),STL1)
                         &&  getbit1(inp(SCANER),STR1)  );
                     motor_brk();
        }
        /*AޯĂEɂꍇAEɉ]B  */
        else  if((      (getbit1(scaner,STR2))
                  ||    (getbit1(scaner,STR3))  )
                  &&    (!getbit1(scaner,STL1))
                  &&    (!getbit1(scaner,STR1))    ){
                     motor_brk();  right_turn();
                     while(  getbit1(inp(SCANER),STL1)
                         &&  getbit1(inp(SCANER),STR1)  );
                     motor_brk();
        }
    }
}

/*-----------------------------------------------------------------------
  DC[^̉]ZbgAu[L
*/
void  fwd(void)         {  outp(MOTOR,FWD);   }   /*  Oi  */
void  back(void)        {  outp(MOTOR,BACK);  }   /*    */
void  right_turn(void)  {  outp(MOTOR,RIGHT); }   /*  E]  */
void  left_turn(void)   {  outp(MOTOR,LEFT);  }   /*  ]  */
void  motor_off(void)   {  outp(MOTOR,BRK);   }   /*  u[L */
void  motor_brk(void)                             /*  u[L(^C}t) */
{   outp(MOTOR,BRK);
    timer(5000);      /*  }ȋt]烂[^AMAی삷邽߂̃^C}  */
}

/*-----------------------------------------------------------------------
  X^[gXCb`܂ő҂
*/
void  wait_start_sw(void)
{
   while(inp(START_SW) & 1);
}

/*-----------------------------------------------------------------------
  ^C̃eiX(iv[v)  
    X^[gXCb`ĂԁA[^ᑬ]BPWMduty:10%
*/
void  maint(void)
{
      led(1);
      for(;;){
        if(!(inp(START_SW)  & 1)){
            fwd();  timer(10);
            back();  timer(90);
        }
        else    motor_off();
    }
}

/*-----------------------------------------------------------------------
  5bԑ҂
*/
void  wait_5_sec(void)
{   int  i;
    for(i=0;i<=4;i++)  delay_1();  
}

/*-----------------------------------------------------------------------
  PIOCjVCY
*/
void  io_initial(void)
{      
    outp(PIOBC,0xcf);    /*PIO_B  11001111B  (ޯĐ)*/
    outp(PIOBC,0x01);    /*PIO_B  0000  0001  (ޯēo͊)*/
    outp(PIOAC,0xcf);    /*PIO_A  11001111B  (ޯĐ)*/
    outp(PIOAC,0xff);    /*PIO_A  11111111B  (ޯēo͊)*/
}


/*-----------------------------------------------------------------------
  LEDݸ
*/
void  led(int  time)
{      int  i;
    while(time--){
       outp(LED_PORT,LED_ON);   for(i=1;i<=1000;i++);
       outp(LED_PORT,LED_OFF);  for(i=1;i<=1000;i++);
    }
}

/*-----------------------------------------------------------------------
  ėpĳ
*/
void  timer(int  time)
{   int  i;
    for(i=0;i<=time;i++);
}

/*-----------------------------------------------------------------------
  ϐLSBmޯĖڂoB޲۸ưƯ  bit  ɑB
*/
int  getbit1(int  l,int  m)
{
    return(  (  l>>m  )  &  1  );
}

/*-----------------------------------------------------------------------
  1secĳ(LEDݸt)
*/
void delay_1(void)
{
      unsigned  int  i;
      outp(LED_PORT,LED_ON);  for(i=0;i<=(TIMER-24000);i++);   
      outp(LED_PORT,LED_OFF); for(i=0;i<=35500;i++);
}


/*-----------------------------------------------------------------------
  dummy  荞ݖgp
*/
void interrupt int1(void)
{;}
